From e4b02023290624b899192f65626f0c0f60d5638c Mon Sep 17 00:00:00 2001
From: Jack Magne <jmagne@dhcp-16-206.sjc.redhat.com>
Date: Tue, 29 Mar 2016 10:39:27 -0700
Subject: [PATCH] Port symkey JNI to Java classes. Ticket #801 : Merge
 pki-symkey into jss

What is supported:

1. Everything that is needed to support Secure Channel Protocol 01.
2. Supports the nist sp800 kdf and the original kdf.
3. Supports key unwrapping used by TPS which was formerly in the symkey JNI.

Requires:

1. A new JSS that supports more advanced symkey operations such as key derivation, more advanced key
unwrapping , and a way to list and identify a given symmetric key by name. Version of new Jss will be forthcoming.

Still to do:

1. Port over the 2 or 3 SCP02 routines from Symkey to use this code.
2. The original symkey will remain in place until we can port over everything.
3. SCP03 support can be added later.

Audit fix.
---
 .../cms/src/com/netscape/cms/servlet/tks/KDF.java  |   67 +
 .../netscape/cms/servlet/tks/NistSP800_108KDF.java |  200 +++
 .../cms/servlet/tks/SecureChannelProtocol.java     | 1412 ++++++++++++++++++++
 .../com/netscape/cms/servlet/tks/StandardKDF.java  |  170 +++
 .../com/netscape/cms/servlet/tks/TokenServlet.java |  140 +-
 .../server/tps/processor/TPSProcessor.java         |   83 +-
 6 files changed, 1987 insertions(+), 85 deletions(-)
 create mode 100644 base/server/cms/src/com/netscape/cms/servlet/tks/KDF.java
 create mode 100644 base/server/cms/src/com/netscape/cms/servlet/tks/NistSP800_108KDF.java
 create mode 100644 base/server/cms/src/com/netscape/cms/servlet/tks/SecureChannelProtocol.java
 create mode 100644 base/server/cms/src/com/netscape/cms/servlet/tks/StandardKDF.java

diff --git a/base/server/cms/src/com/netscape/cms/servlet/tks/KDF.java b/base/server/cms/src/com/netscape/cms/servlet/tks/KDF.java
new file mode 100644
index 0000000..54028af
--- /dev/null
+++ b/base/server/cms/src/com/netscape/cms/servlet/tks/KDF.java
@@ -0,0 +1,67 @@
+package com.netscape.cms.servlet.tks;
+
+import com.netscape.certsrv.apps.CMS;
+import com.netscape.certsrv.base.EBaseException;
+
+public class KDF {
+    /* DES KEY Parity conversion table. Takes each byte >> 1 as an index, returns
+     * that byte with the proper parity bit set*/
+    static final int parityTable[] =
+    {
+            /* Even...0x00,0x02,0x04,0x06,0x08,0x0a,0x0c,0x0e */
+            /* E */0x01, 0x02, 0x04, 0x07, 0x08, 0x0b, 0x0d, 0x0e,
+            /* Odd....0x10,0x12,0x14,0x16,0x18,0x1a,0x1c,0x1e */
+            /* O */0x10, 0x13, 0x15, 0x16, 0x19, 0x1a, 0x1c, 0x1f,
+            /* Odd....0x20,0x22,0x24,0x26,0x28,0x2a,0x2c,0x2e */
+            /* O */0x20, 0x23, 0x25, 0x26, 0x29, 0x2a, 0x2c, 0x2f,
+            /* Even...0x30,0x32,0x34,0x36,0x38,0x3a,0x3c,0x3e */
+            /* E */0x31, 0x32, 0x34, 0x37, 0x38, 0x3b, 0x3d, 0x3e,
+            /* Odd....0x40,0x42,0x44,0x46,0x48,0x4a,0x4c,0x4e */
+            /* O */0x40, 0x43, 0x45, 0x46, 0x49, 0x4a, 0x4c, 0x4f,
+            /* Even...0x50,0x52,0x54,0x56,0x58,0x5a,0x5c,0x5e */
+            /* E */0x51, 0x52, 0x54, 0x57, 0x58, 0x5b, 0x5d, 0x5e,
+            /* Even...0x60,0x62,0x64,0x66,0x68,0x6a,0x6c,0x6e */
+            /* E */0x61, 0x62, 0x64, 0x67, 0x68, 0x6b, 0x6d, 0x6e,
+            /* Odd....0x70,0x72,0x74,0x76,0x78,0x7a,0x7c,0x7e */
+            /* O */0x70, 0x73, 0x75, 0x76, 0x79, 0x7a, 0x7c, 0x7f,
+            /* Odd....0x80,0x82,0x84,0x86,0x88,0x8a,0x8c,0x8e */
+            /* O */0x80, 0x83, 0x85, 0x86, 0x89, 0x8a, 0x8c, 0x8f,
+            /* Even...0x90,0x92,0x94,0x96,0x98,0x9a,0x9c,0x9e */
+            /* E */0x91, 0x92, 0x94, 0x97, 0x98, 0x9b, 0x9d, 0x9e,
+            /* Even...0xa0,0xa2,0xa4,0xa6,0xa8,0xaa,0xac,0xae */
+            /* E */0xa1, 0xa2, 0xa4, 0xa7, 0xa8, 0xab, 0xad, 0xae,
+            /* Odd....0xb0,0xb2,0xb4,0xb6,0xb8,0xba,0xbc,0xbe */
+            /* O */0xb0, 0xb3, 0xb5, 0xb6, 0xb9, 0xba, 0xbc, 0xbf,
+            /* Even...0xc0,0xc2,0xc4,0xc6,0xc8,0xca,0xcc,0xce */
+            /* E */0xc1, 0xc2, 0xc4, 0xc7, 0xc8, 0xcb, 0xcd, 0xce,
+            /* Odd....0xd0,0xd2,0xd4,0xd6,0xd8,0xda,0xdc,0xde */
+            /* O */0xd0, 0xd3, 0xd5, 0xd6, 0xd9, 0xda, 0xdc, 0xdf,
+            /* Odd....0xe0,0xe2,0xe4,0xe6,0xe8,0xea,0xec,0xee */
+            /* O */0xe0, 0xe3, 0xe5, 0xe6, 0xe9, 0xea, 0xec, 0xef,
+            /* Even...0xf0,0xf2,0xf4,0xf6,0xf8,0xfa,0xfc,0xfe */
+            /* E */0xf1, 0xf2, 0xf4, 0xf7, 0xf8, 0xfb, 0xfd, 0xfe, };
+
+    protected byte[] getDesParity(byte[] key) throws EBaseException {
+        String method = "KDF.getDesParity";
+        if (key == null
+                || (key.length != SecureChannelProtocol.DES2_LENGTH && key.length != SecureChannelProtocol.EIGHT_BYTES)) {
+            throw new EBaseException(method + " Incorrect input key !");
+        }
+
+        byte[] desKey = new byte[key.length];
+
+        for (int i = 0; i < key.length; i++) {
+            int index = key[i] & 0xff;
+            int finalIndex = index >> 1;
+
+            byte val = (byte) parityTable[finalIndex];
+            desKey[i] = val;
+
+        }
+
+        CMS.debug("desKey: " + desKey + " len: " + desKey.length);
+
+        return desKey;
+    }
+
+}
diff --git a/base/server/cms/src/com/netscape/cms/servlet/tks/NistSP800_108KDF.java b/base/server/cms/src/com/netscape/cms/servlet/tks/NistSP800_108KDF.java
new file mode 100644
index 0000000..cb614bd
--- /dev/null
+++ b/base/server/cms/src/com/netscape/cms/servlet/tks/NistSP800_108KDF.java
@@ -0,0 +1,200 @@
+package com.netscape.cms.servlet.tks;
+
+import java.util.Arrays;
+import java.util.HashMap;
+import java.util.Map;
+
+import org.mozilla.jss.crypto.CryptoToken;
+import org.mozilla.jss.crypto.HMACAlgorithm;
+import org.mozilla.jss.crypto.JSSMessageDigest;
+import org.mozilla.jss.crypto.SymmetricKey;
+
+import com.netscape.certsrv.apps.CMS;
+import com.netscape.certsrv.base.EBaseException;
+
+public class NistSP800_108KDF extends KDF {
+
+    static final int KDF_OUTPUT_SIZE_BITS = 384;
+    static final int KDF_OUTPUT_SIZE_BYTES = KDF_OUTPUT_SIZE_BITS / 8;
+    static final int KEY_DATA_SIZE_BYTES = KDF_OUTPUT_SIZE_BYTES / 3;
+
+    static final int KDD_SIZE_BYTES = 10; // expected KDD field length in bytes
+
+    static final byte KDF_LABEL = 0x04; // arbitra
+
+    static final int SHA256_LENGTH = 32;
+
+    SecureChannelProtocol protocol = null;
+
+    NistSP800_108KDF(SecureChannelProtocol protocol) {
+        this.protocol = protocol;
+    }
+
+    static public boolean useThisKDF(byte nistSP800_108KDFonKeyVersion, byte requestedKeyVersion) {
+        return (requestedKeyVersion >= nistSP800_108KDFonKeyVersion);
+    }
+
+    //*******************************************************************************
+    // Generates three PK11SymKey objects using the KDF_CM_SHA256HMAC_L384() function for key data.
+    // After calling KDF_CM_SHA256HMAC_L384, the function splits up the output, sets DES parity,
+    //   and imports the keys into the token.
+    //
+    // Careful:  This function currently generates the key data **IN RAM** using calls to NSS sha256.
+    //            The key data is then "unwrapped" (imported) to the NSS token and then erased from RAM.
+    //            (This means that a malicious actor on the box could steal the key data.)
+    //
+    // Note: Returned key material from the KDF is converted into keys according to the following:
+    //   * Bytes 0  - 15 : enc/auth key
+    //   * Bytes 16 - 31 : mac key
+    //   * Bytes 32 - 47 : kek key
+    //   We chose this order to conform with the key order used by the PUT KEY command.
+    //
+    //*******************************************************************************
+
+    public Map<String, SymmetricKey> computeCardKeys(SymmetricKey masterKey, byte[] context, CryptoToken token)
+            throws EBaseException {
+
+        String method = "NistSP800_108KDF.computeCardKeys:";
+
+        if (masterKey == null || context == null || token == null) {
+            throw new EBaseException(method + " Invlalid input parameters!");
+        }
+
+        Map<String, SymmetricKey> keys = new HashMap<String, SymmetricKey>();
+
+        byte[] kdf_output = null;
+
+        kdf_output = kdf_CM_SHA256_HMAC_L384(masterKey, context, KDF_LABEL, KDF_OUTPUT_SIZE_BYTES, token);
+
+        //Now create the 3 keys from only 48 of the 64 bytes...
+
+        byte[] enc = new byte[16];
+        byte[] mac = new byte[16];
+        byte[] kek = new byte[16];
+
+        System.arraycopy(kdf_output, 0 * SecureChannelProtocol.DES2_LENGTH, enc, 0, SecureChannelProtocol.DES2_LENGTH);
+        System.arraycopy(kdf_output, 1 * SecureChannelProtocol.DES2_LENGTH, mac, 0, SecureChannelProtocol.DES2_LENGTH);
+        System.arraycopy(kdf_output, 2 * SecureChannelProtocol.DES2_LENGTH, kek, 0, SecureChannelProtocol.DES2_LENGTH);
+
+        byte[] encFinal = this.getDesParity(enc);
+        byte[] macFinal = this.getDesParity(mac);
+        byte[] kekFinal = this.getDesParity(kek);
+
+        boolean showKeysOnlyForDebug = false;
+
+        if(showKeysOnlyForDebug) {
+            SecureChannelProtocol.debugByteArray(macFinal, " Nist macFinal: ");
+            SecureChannelProtocol.debugByteArray(encFinal, " Nist encFinal: ");
+            SecureChannelProtocol.debugByteArray(kekFinal, " Nist kekFinal: ");
+        }
+
+
+        Arrays.fill(enc, (byte) 0);
+        Arrays.fill(mac, (byte) 0);
+        Arrays.fill(kek, (byte) 0);
+
+        SymmetricKey macKey = protocol.unwrapSymKeyOnToken(token, macFinal, false);
+        SymmetricKey encKey = protocol.unwrapSymKeyOnToken(token, encFinal, false);
+        SymmetricKey kekKey = protocol.unwrapSymKeyOnToken(token, kekFinal, false);
+
+        Arrays.fill(encFinal, (byte) 0);
+        Arrays.fill(macFinal, (byte) 0);
+        Arrays.fill(kekFinal, (byte) 0);
+
+        keys.put(SecureChannelProtocol.macType, macKey);
+        keys.put(SecureChannelProtocol.encType, encKey);
+        keys.put(SecureChannelProtocol.kekType, kekKey);
+
+        return keys;
+
+    }
+
+    //*******************************************************************************
+    // Key Derivation Function in Counter Mode using PRF = SHA256HMAC (NIST SP 800-108)
+    //   Calculates 384 bits of diversified output from the provided master key (K_I)
+    //*******************************************************************************
+
+    private byte[] kdf_CM_SHA256_HMAC_L384(SymmetricKey masterKey, byte[] context, byte kdfLabel,
+            int kdfOutputSizeBytes, CryptoToken token) throws EBaseException {
+
+        String method = "NistSP800_108KDF.cm_SHA256_HMAC_L384:";
+
+        CMS.debug(method + " entering..");
+        final byte n = 2; // ceil(384 / (SHA256LENGTH * 8)) == 2
+        int L_BYTE_array_length = 2; // 384 = 0x0180 hex; 2 byte long representation
+
+        if (context == null) {
+            throw new EBaseException(method + " Input value context  must not be null.");
+        }
+        // sanity check that output buffer is large enough to contain 384 bits
+        if (kdfOutputSizeBytes < KDF_OUTPUT_SIZE_BYTES) {
+            throw new EBaseException(method + " Array \"output\" must be at least 48 bytes in size.");
+        }
+
+        // calculate size of temporary buffer
+        int HMAC_DATA_INPUT_SIZE = context.length + 3 + L_BYTE_array_length; // Don't change without reviewing code below.
+
+        // prevent integer overflow
+        if (HMAC_DATA_INPUT_SIZE < context.length) {
+            throw new EBaseException(method + " Input parameter context size is too large.");
+        }
+
+        byte L_BYTE_array[] = new byte[L_BYTE_array_length]; // Array to store L in BYTES
+        L_BYTE_array[0] = 0x01;
+        L_BYTE_array[1] = (byte) 0x80;
+
+        // Hash Input = context + 5 BYTES
+        byte[] hmac_data_input = new byte[HMAC_DATA_INPUT_SIZE];
+
+        byte[] K = new byte[n * SHA256_LENGTH];
+
+        hmac_data_input[1] = kdfLabel;
+        hmac_data_input[2] = 0x0;
+        System.arraycopy(context, 0, hmac_data_input, 3, context.length);
+        System.arraycopy(L_BYTE_array, 0, hmac_data_input, context.length + 3, 2);
+
+        byte[] outputHMAC256 = null;
+
+        for (byte i = 1; i <= n; i++) {
+            hmac_data_input[0] = i;
+            outputHMAC256 = sha256HMAC(masterKey, hmac_data_input, HMAC_DATA_INPUT_SIZE, token);
+            CMS.debug(method + "outputHMAC256 len: " + outputHMAC256.length);
+            System.arraycopy(outputHMAC256, 0, K, (i - 1) * SHA256_LENGTH, SHA256_LENGTH);
+        }
+
+        CMS.debug(method + " Returning: " + K.length + " bytes...");
+
+        return K;
+    }
+
+    private byte[] sha256HMAC(SymmetricKey masterKey, byte[] hmac_data_input, int hMAC_DATA_INPUT_SIZE,
+            CryptoToken token) throws EBaseException {
+
+        String method = "NistSP800_108KDF.sha256HMAC:";
+
+        CMS.debug(method + " Entering...");
+
+        byte[] digestBytes = null;
+
+        if (token == null) {
+            throw new EBaseException(method = " Invalid Crypto Token input!");
+        }
+
+        try {
+            JSSMessageDigest digest = token.getDigestContext(HMACAlgorithm.SHA256);
+            digest.initHMAC(masterKey);
+
+            digestBytes = digest.digest(hmac_data_input);
+        } catch (Exception e) {
+
+            CMS.debug(method + " Failure to HMAC the input data: " + e);
+            throw new EBaseException(method + e);
+        }
+
+        SecureChannelProtocol.debugByteArray(digestBytes, " output of sha256HMAC: ");
+
+        return digestBytes;
+    }
+
+
+}
